#include "C:\Source\ClientCore.cpp"

BOOL PRIVATE OnGameCommandSel(char** argv, int argc);
BOOL PRIVATE OnGameCommandFollow(char** argv, int argc);
BOOL PRIVATE OnGameCommandRelease(char** argv, int argc);
BOOL PRIVATE OnGameCommandHelp(char** argv, int argc);
BOOL PRIVATE OnGameCommandInteract(char** argv, int argc);

BOOL getTarget = false;
BOOL grabedTarget = false;
BOOL walkControl = true;
BOOL lastknown = false;

INT wTick = 0;

BYTE NPCTarget[8] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
BYTE NPCx[2] = {0x00, 0x00};
BYTE NPCy[2] = {0x00, 0x00};
BYTE NPCFinal[17] = {0x59, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
BYTE NPCInteract[9] = {0x13, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};


MODULECOMMANDSTRUCT ModuleCommands[]=
{
	{
		"help",
		OnGameCommandHelp,
		"Displays help textc0"
	}, 
	{
		"sel",
		OnGameCommandSel,
		"Selects the target NPC."
	},	
	{
		"clear",
		OnGameCommandRelease,
		"Releases the target NPC from control."
	},	
	{
		"followtog",
		OnGameCommandFollow,
		"Toggles the NPC following."
	},
	{
		"interact",
		OnGameCommandInteract,
		"Interacts with the NPC just for those special moments :)."
	},
	{NULL} 
};

CLIENTINFO
(
0,1,
"Magichound",
"http://www.realmgx.com",
"NPCLeader",
"Magichound@Gmail.com"
)

VOID EXPORT OnGameJoin(THISGAMESTRUCT* thisgame)
{
   return;
}

VOID EXPORT OnGameLeave(THISGAMESTRUCT* thisgame)
{
	// Reset our varibles.
	getTarget = false;
	grabedTarget = false;
	lastknown = false;
	return;
}

DWORD EXPORT OnGamePacketBeforeReceived(BYTE* aPacket, DWORD aLen)
{
   return aLen;
}

DWORD EXPORT OnGamePacketBeforeSent(BYTE* aPacket, DWORD aLen)
{
	if(aPacket[0] == 0x13 && aPacket[1] == 0x01 && (getTarget))
	{
		memcpy(NPCTarget,aPacket+1,8);
		server->GamePrintInfo("The selected NPC is ready for control.");
		getTarget = false;
		grabedTarget = true;
		lastknown = true;
	}

	if(aPacket[0] == 0x01 || aPacket[0] == 0x03)
	{
		if ((grabedTarget) && (walkControl))
		{
			// Copys the coords down just for safe keeping.
			memcpy(NPCx,aPacket+1,2);
			memcpy(NPCy,aPacket+3,2);

			// Builds the final packet
			memcpy(NPCFinal+1,NPCTarget,8);	
			memcpy(NPCFinal+9,NPCx,2);
			memcpy(NPCFinal+13,NPCy,2);	
			wTick++;
			if (wTick == 5)
			{
				wTick = 0;
				server->GameSendPacketToServer(NPCFinal,sizeof(NPCFinal));
			}
		}
		
	}
	return aLen;
}

BOOL PRIVATE OnGameCommandSel(char** argv, int argc)
{
	server->GamePrintInfo("Please select the target NPC you wish to control."); // Prints text to the client.
	getTarget = true;
	return true;
}

BOOL PRIVATE OnGameCommandRelease(char** argv, int argc)
{
	if(grabedTarget) { server->GamePrintInfo("You have released the NPC from control."); }
	grabedTarget = false;
	return true;
}

BOOL PRIVATE OnGameCommandInteract(char** argv, int argc)
{
	if(grabedTarget)
	{
		server->GamePrintInfo("Trying to interact with NPC..."); // Prints text to the client.
		memcpy(NPCInteract+1,NPCTarget,8);
		server->GameSendPacketToServer(NPCInteract,sizeof(NPCInteract));
	}
	else if (lastknown)
	{
		server->GamePrintInfo("Trying to interact with last known NPC..."); // Prints text to the client.
		memcpy(NPCInteract+1,NPCTarget,8);
		server->GameSendPacketToServer(NPCInteract,sizeof(NPCInteract));
	}
	else { server->GamePrintInfo("You have not selected a NPC to control."); }
	return true;
}

BOOL PRIVATE OnGameCommandFollow(char** argv, int argc)
{
	if(walkControl)
	{
		walkControl = false;
		server->GamePrintInfo("You have disabled NPC following.");
	}
	else
	{
		walkControl = true;
		server->GamePrintInfo("You have enabled NPC following.");
	}
	return true;
}

DWORD EXPORT OnGameTimerTick(void)
{
   return 0;
} 